## iscsitarget 0.4.15

=== Makefile ===
#
# Makefile for the Linux kernel device drivers.
#
# Note! Dependencies are done automagically by 'make dep', which also
# removes any old dependencies. DON'T put your own dependencies here
# unless it's something special (not a .c file).
#
# Note 2! The CFLAGS definitions are now in the main makefile.

#export KSRC := /usr/src/linux

SUBDIRS := $(shell pwd)

ifeq ($(KSRC),)
	KSRC ?= /lib/modules/$(shell uname -r)/build
endif

ifneq ($(wildcard $(KSRC)/include/linux/utsrelease.h),)
	VERSION_FILE := $(KSRC)/include/linux/utsrelease.h
else
	VERSION_FILE := $(KSRC)/include/linux/version.h
endif

KVER := $(shell $(CC) $(CFLAGS) -E -dM $(VERSION_FILE) | \
	grep UTS_RELEASE | awk '{ print $$3 }' | sed 's/\"//g')

KMOD := /lib/modules/$(KVER)/kernel

KMAJ := $(shell echo $(KVER) | \
	sed -e 's/^\([0-9][0-9]*\)\.[0-9][0-9]*\.[0-9][0-9]*.*/\1/')
KMIN := $(shell echo $(KVER) | \
	sed -e 's/^[0-9][0-9]*\.\([0-9][0-9]*\)\.[0-9][0-9]*.*/\1/')
KREV := $(shell echo $(KVER) | \
	sed -e 's/^[0-9][0-9]*\.[0-9][0-9]*\.\([0-9][0-9]*\).*/\1/')

kver_eq = $(shell [ $(KMAJ)$(KMIN)$(KREV) -eq $(1)$(2)$(3) ] && \
	echo 1 || echo 0)
kver_lt = $(shell [ $(KMAJ)$(KMIN)$(KREV) -lt $(1)$(2)$(3) ] && \
	echo 1 || echo 0)
kver_le = $(shell [ $(KMAJ)$(KMIN)$(KREV) -le $(1)$(2)$(3) ] && \
	echo 1 || echo 0)
kver_gt = $(shell [ $(KMAJ)$(KMIN)$(KREV) -gt $(1)$(2)$(3) ] && \
	echo 1 || echo 0)
kver_ge = $(shell [ $(KMAJ)$(KMIN)$(KREV) -ge $(1)$(2)$(3) ] && \
	echo 1 || echo 0)
kver_lk = $(shell [ `echo $(KVER) | egrep $(1)` ] && echo 1 || echo 0)

#
# Please when adding patch sets start with the latest to the earliest
# the idea behind this is that by properly patching the latest code
# base first the earlier patch sets will not need to be modified.
#

# Compatibility patch for kernels >= 2.6.14 and <= 2.6.18
ifeq ($(call kver_le,2,6,18),1)
	PATCHES := $(PATCHES) compat-2.6.14-2.6.18.patch
endif

# We don't support kernels < 2.6.14 except for explicit distros
ifeq ($(call kver_lt,2,6,14),1)
	UNSUPPORTED := true
endif

# Compatibility patch for RHEL4/CentOS4
ifeq ($(call kver_lk,"2\.6\.9-.*\.(EL|plus\.c4)"),1)
	PATCHES += compat-rhel4.patch
	UNSUPPORTED :=
endif

MANPAGES:= ietadm.8 ietd.8 ietd.conf.5

ifeq ($(MANDIR),)
	MANPATH := $(shell (manpath 2>/dev/null || \
		echo $MANPATH) | sed 's/:/ /g')
	ifneq ($(MANPATH),)
		test_dir = $(findstring $(dir), $(MANPATH))
	else
		test_dir = $(shell [ -e $(dir) ] && echo $(dir))
	endif
	MANDIR := /usr/share/man /usr/man
	MANDIR := $(foreach dir, $(MANDIR), $(test_dir))
	MANDIR := $(firstword $(MANDIR))
endif

ifeq ($(MANDIR),)
	MANDIR := /usr/share/man
endif

DOCS:= ChangeLog COPYING README README.vmware

ifeq ($(DOCDIR),)
	DOCDIR := /usr/share/doc/iscsitarget
endif

all: usr kernel

usr: patch
	$(MAKE) -C usr

kernel: patch
	$(MAKE) -C $(KSRC) SUBDIRS=$(shell pwd)/kernel modules

patch: $(UNSUPPORTED) integ_check $(PATCHES)

$(UNSUPPORTED):
	@echo "Sorry, your kernel version and/or distribution is currently"
	@echo "not supported."
	@echo ""
	@echo "Please read the README file for information on how you can"
	@echo "contribute compatibility/bug fixes to the IET project."
	@exit 1

integ_check:
	@if [ -e .patched.* -a ! -e .patched.$(KVER) ]; then \
		$(MAKE) unpatch; \
	fi

$(PATCHES): .patched.$(KVER)

.patched.$(KVER):
	@set -e; \
	if [ ! -e .patched.* ]; then \
		for p in $(PATCHES); do \
			echo "Applying Patch $$p"; \
			patch -p0 < patches/$$p; \
			echo $$p >>.patched.$(KVER); \
		done; \
	fi

unpatch:
	@set -e; \
	if [ -e .patched.* ]; then \
		for p in `cat .patched.*`; do \
			reverse="$$p $$reverse"; \
		done; \
		for r in $$reverse; do \
			echo "Reversing patch $$r"; \
			patch -p0 -R < patches/$$r; \
		done; \
		rm -f .patched.*; \
	fi

install: install-kernel install-usr install-etc install-doc

install-kernel: kernel/iscsi_trgt.ko
	@install -vD kernel/iscsi_trgt.ko \
		$(DISTDIR)$(INSTALL_MOD_PATH)$(KMOD)/iscsi/iscsi_trgt.ko
	-depmod -aq

install-usr: usr/ietd usr/ietadm
	@install -vD usr/ietd $(DISTDIR)/usr/sbin/ietd
	@install -vD usr/ietadm $(DISTDIR)/usr/sbin/ietadm

install-etc: install-initd
	@if [ ! -e /etc/ietd.conf ]; then \
		install -vD -m 644 etc/ietd.conf \
			$(DISTDIR)/etc/ietd.conf; \
	fi
	@if [ ! -e /etc/initiators.allow ]; then \
		install -vD -m 644 etc/initiators.allow \
			$(DISTDIR)/etc/initiators.allow; \
	fi
	@if [ ! -e /etc/initiators.deny ]; then \
		install -vD -m 644 etc/initiators.deny \
			$(DISTDIR)/etc/initiators.deny; \
	fi

install-initd:
	@if [ -f /etc/debian_version ]; then \
		install -vD -m 755 etc/initd/initd.debian \
			$(DISTDIR)/etc/init.d/iscsi-target; \
	elif [ -f /etc/redhat-release ]; then \
		install -vD -m 755 etc/initd/initd.redhat \
			$(DISTDIR)/etc/init.d/iscsi-target; \
	elif [ -f /etc/gentoo-release ]; then \
		install -vD -m 755 etc/initd/initd.gentoo \
			$(DISTDIR)/etc/init.d/iscsi-target; \
	elif [ -f /etc/slackware-version ]; then \
		install -vD -m 755 etc/initd/initd \
			$(DISTDIR)/etc/rc.d/iscsi-target; \
	else \
		install -vD -m 755 etc/initd/initd \
			$(DISTDIR)/etc/init.d/iscsi-target; \
	fi

install-doc: install-man
	@ok=true; for f in $(DOCS) ; \
		do [ -e $$f ] || \
			{ echo $$f missing ; ok=false; } ; \
	done ; $$ok
	@set -e; for f in $(DOCS) ; do \
		install -v -D -m 644 $$f \
			$(DISTDIR)$(DOCDIR)/$$f ; \
	done

install-man:
	@ok=true; for f in $(MANPAGES) ; \
		do [ -e doc/manpages/$$f ] || \
			{ echo doc/manpages/$$f missing ; ok=false; } ; \
	done ; $$ok
	@set -e; for f in $(MANPAGES) ; do \
		s=$${f##*.}; \
		install -v -D -m 644 doc/manpages/$$f \
			$(DISTDIR)$(MANDIR)/man$$s/$$f ; \
	done

uninstall: uninstall-kernel uninstall-usr uninstall-etc uninstall-doc

uninstall-kernel:
	rm -f $(DISTDIR)$(INSTALL_MOD_PATH)$(KMOD)/iscsi/iscsi_trgt.ko
	-depmod -aq

uninstall-usr:
	@rm -f $(DISTDIR)/usr/sbin/ietd
	@rm -f $(DISTDIR)/usr/sbin/ietadm

uninstall-etc: uninstall-initd

uninstall-initd:
	if [ -f /etc/debian_version ]; then \
		rm -f $(DISTDIR)/etc/init.d/iscsi-target; \
	elif [ -f /etc/redhat-release ]; then \
		rm -f $(DISTDIR)/etc/init.d/iscsi-target; \
	elif [ -f /etc/gentoo-release ]; then \
		rm -f $(DISTDIR)/etc/init.d/iscsi-target; \
	elif [ -f /etc/slackware-version ]; then \
		rm -f $(DISTDIR)/etc/rc.d/iscsi-target; \
	else \
		rm -f $(DISTDIR)/etc/init.d/iscsi-target; \
	fi

uninstall-doc: uninstall-man
	rm -rf $(DISTDIR)$(DOCDIR)

uninstall-man:
	set -e; for f in $(MANPAGES) ; do \
		s=$${f##*.}; \
		rm -f $(DISTDIR)$(MANDIR)/man$$s/$$f ; \
	done

clean:
	$(MAKE) -C usr clean
	$(MAKE) -C $(KSRC) SUBDIRS=$(shell pwd)/kernel clean

distclean: unpatch clean
	find . -name \*.orig -exec rm -f \{\} \;
	find . -name \*.rej -exec rm -f \{\} \;
	find . -name \*~ -exec rm -f \{\} \;
	find . -name Module.symvers -exec rm -f \{\} \;

=== kernel/Makefile ===
#
# Makefile for the Linux kernel device drivers.
#
# Note! Dependencies are done automagically by 'make dep', which also
# removes any old dependencies. DON'T put your own dependencies here
# unless it's something special (not a .c file).
#
# Note 2! The CFLAGS definitions are now in the main makefile.

EXTRA_CFLAGS += -I$(src)/../include 

obj-m		+= iscsi_trgt.o
iscsi_trgt-objs	:= tio.o iscsi.o nthread.o wthread.o config.o digest.o \
			conn.o session.o target.o volume.o iotype.o \
			file-io.o null-io.o target_disk.o event.o param.o \
			block-io.o

=== usr/Makefile ===
CFLAGS += -O2 -fno-inline -Wall -Wstrict-prototypes -g -I../include
PROGRAMS = ietd ietadm
LIBS = -lcrypto

all: $(PROGRAMS)

ietd: ietd.o iscsid.o conn.o session.o target.o message.o ctldev.o log.o chap.o event.o param.o plain.o isns.o

	$(CC) $^ -o $@ $(LIBS)

ietadm: ietadm.o param.o
	$(CC) $^ -o $@

clean:
	rm -f *.o $(PROGRAMS)

## iscsitarget 0.4.16+svn162

=== Makefile ===
--- 
+++ 
@@ -50,6 +50,16 @@
 # the idea behind this is that by properly patching the latest code
 # base first the earlier patch sets will not need to be modified.
 #
+
+# Compatibility patch for kernels >= 2.6.22 and <= 2.6.23
+ifeq ($(call kver_le,2,6,23),1)
+	PATCHES := $(PATCHES) compat-2.6.22-2.6.23.patch
+endif
+
+# Compatibility patch for kernels >= 2.6.19 and <= 2.6.21
+ifeq ($(call kver_le,2,6,21),1)
+	PATCHES := $(PATCHES) compat-2.6.19-2.6.21.patch
+endif
 
 # Compatibility patch for kernels >= 2.6.14 and <= 2.6.18
 ifeq ($(call kver_le,2,6,18),1)
@@ -140,27 +150,34 @@
 		rm -f .patched.*; \
 	fi
 
-install: install-kernel install-usr install-etc install-doc
+depmod:
+	@echo "Running depmod"
+	@if [ x$(DISTDIR) != x -o x$(INSTALL_MOD_PATH) != x ]; then \
+		depmod -aq -b $(DISTDIR)$(INSTALL_MOD_PATH) $(KVER); \
+	else \
+		depmod -aq $(KVER); \
+	fi
+
+install: install-usr install-etc install-doc install-kernel depmod
 
 install-kernel: kernel/iscsi_trgt.ko
 	@install -vD kernel/iscsi_trgt.ko \
 		$(DISTDIR)$(INSTALL_MOD_PATH)$(KMOD)/iscsi/iscsi_trgt.ko
-	-depmod -aq
 
 install-usr: usr/ietd usr/ietadm
 	@install -vD usr/ietd $(DISTDIR)/usr/sbin/ietd
 	@install -vD usr/ietadm $(DISTDIR)/usr/sbin/ietadm
 
 install-etc: install-initd
-	@if [ ! -e /etc/ietd.conf ]; then \
+	@if [ ! -e $(DISTDIR)/etc/ietd.conf ]; then \
 		install -vD -m 644 etc/ietd.conf \
 			$(DISTDIR)/etc/ietd.conf; \
 	fi
-	@if [ ! -e /etc/initiators.allow ]; then \
+	@if [ ! -e $(DISTDIR)/etc/initiators.allow ]; then \
 		install -vD -m 644 etc/initiators.allow \
 			$(DISTDIR)/etc/initiators.allow; \
 	fi
-	@if [ ! -e /etc/initiators.deny ]; then \
+	@if [ ! -e $(DISTDIR)/etc/initiators.deny ]; then \
 		install -vD -m 644 etc/initiators.deny \
 			$(DISTDIR)/etc/initiators.deny; \
 	fi
@@ -204,11 +221,10 @@
 			$(DISTDIR)$(MANDIR)/man$$s/$$f ; \
 	done
 
-uninstall: uninstall-kernel uninstall-usr uninstall-etc uninstall-doc
+uninstall: uninstall-kernel depmod uninstall-usr uninstall-etc uninstall-doc
 
 uninstall-kernel:
 	rm -f $(DISTDIR)$(INSTALL_MOD_PATH)$(KMOD)/iscsi/iscsi_trgt.ko
-	-depmod -aq
 
 uninstall-usr:
 	@rm -f $(DISTDIR)/usr/sbin/ietd

## iscsitarget 1.4.19+svn275-ubuntu2

=== Makefile ===
--- 
+++ 
@@ -24,7 +24,7 @@
 KVER := $(shell $(CC) $(CFLAGS) -E -dM $(VERSION_FILE) | \
 	grep UTS_RELEASE | awk '{ print $$3 }' | sed 's/\"//g')
 
-KMOD := /lib/modules/$(KVER)/kernel
+KMOD := /lib/modules/$(KVER)/extra
 
 KMAJ := $(shell echo $(KVER) | \
 	sed -e 's/^\([0-9][0-9]*\)\.[0-9][0-9]*\.[0-9][0-9]*.*/\1/')
@@ -51,9 +51,34 @@
 # base first the earlier patch sets will not need to be modified.
 #
 
-# Compatibility patch for kernels >= 2.6.22 and <= 2.6.23
+# Compatibility patch for kernels <= 2.6.29
+ifeq ($(call kver_le,2,6,29),1)
+	PATCHES := $(PATCHES) compat-2.6.29.patch
+endif
+
+# Compatibility patch for kernels <= 2.6.28
+ifeq ($(call kver_le,2,6,28),1)
+	PATCHES := $(PATCHES) compat-2.6.28.patch
+endif
+
+# Compatibility patch for kernels >= 2.6.25 and <= 2.6.27
+ifeq ($(call kver_le,2,6,27),1)
+	PATCHES := $(PATCHES) compat-2.6.25-2.6.27.patch
+endif
+
+# Compatibility patch for kernels <= 2.6.24
+ifeq ($(call kver_le,2,6,24),1)
+	PATCHES := $(PATCHES) compat-2.6.24.patch
+endif
+
+# Compatibility patch for kernels <= 2.6.23
 ifeq ($(call kver_le,2,6,23),1)
-	PATCHES := $(PATCHES) compat-2.6.22-2.6.23.patch
+	PATCHES := $(PATCHES) compat-2.6.23.patch
+endif
+
+# Compatibility patch for kernels <= 2.6.22
+ifeq ($(call kver_le,2,6,22),1)
+	PATCHES := $(PATCHES) compat-2.6.22.patch
 endif
 
 # Compatibility patch for kernels >= 2.6.19 and <= 2.6.21
@@ -71,10 +96,22 @@
 	UNSUPPORTED := true
 endif
 
-# Compatibility patch for RHEL4/CentOS4
-ifeq ($(call kver_lk,"2\.6\.9-.*\.(EL|plus\.c4)"),1)
-	PATCHES += compat-rhel4.patch
-	UNSUPPORTED :=
+# Compatibility patches for SuSE distros
+ifneq ($(wildcard /etc/SuSE-release),)
+	# Compatibility patch for SLES 10 SP2
+	ifeq ($(call kver_lk,"2\.6\.16\.60-.*"),1)
+		PATCHES += compat-sles10sp2.patch
+		UNSUPPORTED :=
+	endif
+endif
+
+# Compatibility patches for Redhat distros
+ifneq ($(wildcard /etc/redhat-release),)
+	# Compatibility patch for RHEL4/CentOS4
+	ifeq ($(call kver_lk,"2\.6\.9-.*\.(EL|plus\.c4)"),1)
+		PATCHES += compat-rhel4.patch
+		UNSUPPORTED :=
+	endif
 endif
 
 MANPAGES:= ietadm.8 ietd.8 ietd.conf.5
@@ -96,7 +133,7 @@
 	MANDIR := /usr/share/man
 endif
 
-DOCS:= ChangeLog COPYING README README.vmware
+DOCS:= ChangeLog COPYING RELEASE_NOTES README README.vmware README.initiators
 
 ifeq ($(DOCDIR),)
 	DOCDIR := /usr/share/doc/iscsitarget
@@ -132,7 +169,7 @@
 	if [ ! -e .patched.* ]; then \
 		for p in $(PATCHES); do \
 			echo "Applying Patch $$p"; \
-			patch -p0 < patches/$$p; \
+			patch -p1 < patches/$$p; \
 			echo $$p >>.patched.$(KVER); \
 		done; \
 	fi
@@ -145,7 +182,7 @@
 		done; \
 		for r in $$reverse; do \
 			echo "Reversing patch $$r"; \
-			patch -p0 -R < patches/$$r; \
+			patch -p1 -R < patches/$$r; \
 		done; \
 		rm -f .patched.*; \
 	fi
@@ -158,7 +195,9 @@
 		depmod -aq $(KVER); \
 	fi
 
-install: install-usr install-etc install-doc install-kernel depmod
+install-files: install-usr install-etc install-doc install-kernel
+
+install: install-files depmod
 
 install-kernel: kernel/iscsi_trgt.ko
 	@install -vD kernel/iscsi_trgt.ko \
@@ -170,16 +209,22 @@
 
 install-etc: install-initd
 	@if [ ! -e $(DISTDIR)/etc/ietd.conf ]; then \
-		install -vD -m 644 etc/ietd.conf \
-			$(DISTDIR)/etc/ietd.conf; \
+		if [ ! -e $(DISTDIR)/etc/iet/ietd.conf ]; then \
+			install -vD -m 640 etc/ietd.conf \
+				$(DISTDIR)/etc/iet/ietd.conf; \
+		fi \
 	fi
 	@if [ ! -e $(DISTDIR)/etc/initiators.allow ]; then \
-		install -vD -m 644 etc/initiators.allow \
-			$(DISTDIR)/etc/initiators.allow; \
-	fi
-	@if [ ! -e $(DISTDIR)/etc/initiators.deny ]; then \
-		install -vD -m 644 etc/initiators.deny \
-			$(DISTDIR)/etc/initiators.deny; \
+		if [ ! -e $(DISTDIR)/etc/iet/initiators.allow ]; then \
+			install -vD -m 644 etc/initiators.allow \
+				$(DISTDIR)/etc/iet/initiators.allow; \
+		fi \
+	fi
+	@if [ ! -e $(DISTDIR)/etc/targets.allow ]; then \
+		if [ ! -e $(DISTDIR)/etc/iet/targets.allow ]; then \
+			install -vD -m 644 etc/targets.allow \
+				$(DISTDIR)/etc/iet/targets.allow; \
+		fi \
 	fi
 
 install-initd:

=== debian/changelog ===
iscsitarget (1.4.19+svn275-ubuntu2) lucid; urgency=low

  * Install /etc/targets.allow.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 23 Apr 2010 20:30:40 +0100

iscsitarget (1.4.19+svn275-ubuntu1) lucid; urgency=low

  * Merge from upstream SVN repo at
    svn://svn.berlios.de/iscsitarget/trunk
    -LP: #494693

 -- Tim Gardner <tim.gardner@canonical.com>  Wed, 09 Dec 2009 18:25:18 +0000

iscsitarget (0.4.16+svn162-3ubuntu1) jaunty; urgency=low

  * Merge from debian unstable, remaining changes (LP: #310321):
    - debian/control: Depend on lsb-base >= 3.2-14.
    - debian/prerm: Maintainer script to allow intrepid->jaunty upgrades of 
      iscsitarget to succeed.
    - debian/iscsitarget.init: lsb-ized the entire init script.

 -- Nick Ellery <nick.ellery@ubuntu.com>  Sun, 21 Dec 2008 13:40:23 -0800

iscsitarget (0.4.16+svn162-3) unstable; urgency=medium

  [ Jon Dowland ]
  * Add /etc/default/iscsitarget to determine whether to
    start the iscsitarget automatically or not. Default to
    not (environment might not have the correct module).
    Closes: #506099.

 -- Frederik Schüler <fs@debian.org>  Wed, 03 Dec 2008 15:07:17 +0100

iscsitarget (0.4.16+svn162-2ubuntu2) jaunty; urgency=low

  * debian/iscsitarget.prerm: Maintainer script to allow intrepid->jaunty
    upgrades of iscsitarget to succeed, if using the buggy iscsi_trgt.ko
    module that won't unload properly.

 -- Dustin Kirkland <kirkland@ubuntu.com>  Mon, 24 Nov 2008 16:44:39 -0600

iscsitarget (0.4.16+svn162-2ubuntu1) jaunty; urgency=low

  * Merge from debian unstable, fixes LP: #298520
   - Remaining changes:
    + debian/iscsitarget.init: lsb-ized the entire init script
      (Debian Bug: #506588)
    + debian/control: depend on lsb-base >= 3.2-14
   - Dropped changes:
    + debian/rules, usr/misc.h: -D_GNU_SOURCE no longer required,
      __qelem is explicitly defined by source

 -- Dustin Kirkland <kirkland@ubuntu.com>  Sat, 22 Nov 2008 15:14:12 -0600

iscsitarget (0.4.16+svn162-2) unstable; urgency=high

  * Fix initscript. (Closes: #484107)

 -- Frederik Schüler <fs@debian.org>  Sat, 04 Oct 2008 20:27:14 +0200

iscsitarget (0.4.16+svn162-1) unstable; urgency=low

  * New upstream snapshot.
  * Fix bashism in initscript. (Closes: #486035)
  * Bump standards to 3.8.0, no changes needed.
  * List all copyright holders and contributors in the copyright file.

 -- Frederik Schüler <fs@debian.org>  Mon, 30 Jun 2008 00:11:39 +0200

iscsitarget (0.4.15+svn148-2.1ubuntu2) intrepid; urgency=low

  * debian/rules, usr/misc.h:
    + Use of struct cred required -D_GNU_SOURCE (LP: #247360)
    + Enabling -D_GNU_SOURCE defines struct qelem so the local
        definition is unnessecary.

 -- Bobby R. Ward <bobbyrward@gmail.com>  Thu, 10 Jul 2008 19:03:55 +0000

iscsitarget (0.4.15+svn148-2.1ubuntu1) intrepid; urgency=low

  * Merge from debian unstable, remaining changes:
    - Update kernel modules to build for several architectures.
    - Fixed init script.

 -- Chuck Short <zulcss@ubuntu.com>  Tue, 17 May 2008 10:03:55 -0500

iscsitarget (0.4.15+svn148-2.1) unstable; urgency=low

  * Non-maintainer upload
  * Fix failure to build kernel modules for several architectures with
    kernel version 2.6.24 or later. (Closes: #480734)

 -- Ben Hutchings <ben@decadent.org.uk>  Mon, 19 May 2008 02:01:36 +0100

iscsitarget (0.4.15+svn148-2) unstable; urgency=high

  * Fix initscript, thanks to Gilles Mocellin for the patch. (Closes: #470411)

 -- Frederik Schüler <fs@debian.org>  Tue, 11 Mar 2008 23:01:45 +0100

iscsitarget (0.4.15+svn148-1) unstable; urgency=low

  * New upstream snapshot.
    - Adds support for 2.6.24 kernels. (Closes: #461753)
  * Fix bashism in initscript.(Closes: #464993)

 -- Frederik Schüler <fs@debian.org>  Tue, 19 Feb 2008 20:52:01 +0100

iscsitarget (0.4.15+svn145-1) unstable; urgency=low

  * New upstream snapshot.
    - support 2.6.23 kernels. (Closes: #449237)
    - fix ia64 FTBFS. (Closes: #457615)
  * Update to standards version 3.7.3, no changes needed.
  * Fix kbuild-clean target, thanks to Jeremy Laine <jeremy.laine@m4x.org>
    for the fix.
  * Add lsb section to the iscsitarget initscript.
  * Add lintian override for /etc/ietd.conf permissions.

 -- Frederik Schüler <fs@debian.org>  Sat, 29 Dec 2007 22:53:26 +0100

iscsitarget (0.4.15-5ubuntu2) hardy; urgency=low

  * Correct bashisms in init script (LP: #160106)
  * Set maintainer to MOTU

 -- John Dong <jdong@ubuntu.com>  Thu, 31 Jan 2008 09:28:53 -0500

iscsitarget (0.4.15-5ubuntu1) hardy; urgency=low

  * Fix kernel source to build with 2.6.24.

 -- Chuck Short <zulcss@ubuntu.com>  Tue, 29 Jan 2008 08:56:31 -0500

iscsitarget (0.4.15-5) unstable; urgency=high

  * Urgenc: high due to security update.
  * Fix /etc/ietd.conf permissions. (Closes: #448873)
  * Fix module-assistant build. Thanks to Franklin PIAT <fpiat@bigfoot.com>
    for the patch. (Closes: #448195)

 -- Frederik Schüler <fs@debian.org>  Sun, 04 Nov 2007 18:54:41 +0100

iscsitarget (0.4.15-4) unstable; urgency=low

  [ Frederik Schüler ]
  * Fix build failure on linux-2.6.22 (Closes: #432522)
  * Add toplevel Makefile to the module sources (Closes: #431765)
  * iscsitarget-source: do not recommend iscsitarget (Closes: #433318)

 -- Frederik Schüler <fs@debian.org>  Mon, 24 Sep 2007 12:15:50 +0200

iscsitarget (0.4.15-3) unstable; urgency=low

  * Don't depend on iscsitarget-module (Closes: #431302)

 -- Philipp Hug <debian@hug.cx>  Mon, 02 Jul 2007 15:39:36 +0200

iscsitarget (0.4.15-2) unstable; urgency=low

  * Uploaded to unstable

 -- Philipp Hug <debian@hug.cx>  Sat, 16 Jun 2007 21:48:42 +0200

iscsitarget (0.4.15-1) experimental; urgency=low

  * New upstream release
  * Uploaded to experimental (Closes: #304330)

 -- Philipp Hug <debian@hug.cx>  Mon, 16 Apr 2007 22:18:57 +0200

iscsitarget (0.4.14+svn92-1) UNRELEASED; urgency=low

  * New upstream snapshot for kernels 2.6.19 and later.

 -- Frederik Schüler <fs@debian.org>  Sun, 14 Jan 2007 23:05:56 +0100



=== debian/control ===
Source: iscsitarget
Section: net
Priority: optional
Maintainer: Ubuntu MOTU Developers <ubuntu-motu@lists.ubuntu.com>
XSBC-Original-Maintainer: Philipp Hug <debian@hug.cx>
Uploaders: Frederik Schüler <fs@debian.org>
Build-Depends: debhelper (>= 5.0.0), libssl-dev, bzip2
Standards-Version: 3.8.0
Homepage: http://iscsitarget.sourceforge.net/

Package: iscsitarget
Architecture: any
Depends: ${shlibs:Depends}, lsb-base (>= 3.2-14)
Recommends: iscsitarget-module
Suggests: iscsitarget-source
Description: iSCSI Enterprise Target userland tools
 iSCSI Enterprise Target is for building an iSCSI storage system on
 Linux. It is aimed at developing an iSCSI target satisfying enterprise
 requirements.
 .
 This package contains the userland part; you require the kernel module 
 for proper operation.

Package: iscsitarget-source
Architecture: all
Depends: debhelper (>= 5.0.0), module-assistant, bzip2
Description: iSCSI Enterprise Target kernel module source
 iSCSI Enterprise Target is for building an iSCSI storage system on
 Linux. It is aimed at developing an iSCSI target satisfying enterprise
 requirements.
 .
 This package provides the source code for the iscsitarget kernel module.
 The iscsitarget package is also required in order to make use of this
 module. Kernel source or headers are required to compile this module.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

non_epoch_version=$(shell echo $(KVERS) | perl -pe 's/^\d+://')

PACKAGE=iscsitarget
psource=iscsitarget-source
pmodules = $(PACKAGE)-module-$(non_epoch_version)

MA_DIR ?= /usr/share/modass
-include $(MA_DIR)/include/generic.make
-include $(MA_DIR)/include/common-rules.make

CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

# module-assistant stuff
MAJOR=$(shell echo $(KVERS) | sed -e 's/\(...\).*/\1/')
ifeq ($(MAJOR),2.6)
KO=k
endif

kdist_clean:
	dh_clean
	 $(MAKE) -C $(KSRC) SUBDIRS=$(shell pwd)/kernel clean

# prep-deb-files rewrites the debian/ files as needed. See RATIONALE for
# details
kdist_config: prep-deb-files
# ... additional kernel specific things to configure...

kdist_configure: kdist_config

binary-modules: prep-deb-files
	dh_testdir
	dh_testroot
	dh_clean -k
	#$(MAKE) -C $(KSRC) KERNEL_SOURCES=$(KSRC) MODVERSIONS=detect KERNEL=linux-$(KVERS) KDIR=$(KSRC) SUBDIRS=$(shell pwd)/kernel modules
	$(MAKE) -C $(KSRC) SUBDIRS=$(shell pwd)/kernel modules
	
	#$(MAKE) -C $(KSRC) SUBDIRS=$(shell pwd)/kernel modules_install DESTDIR=$(CURDIR)/debian/$(pmodules)
	install -m644 -b -D $(shell pwd)/kernel/iscsi_trgt.$(KO)o $(CURDIR)/debian/${pmodules}/lib/modules/$(KVERS)/kernel/drivers/iscsi/iscsi_trgt.$(KO)o

	dh_installdocs
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol -- -v$(VERSION)
	dh_md5sums
	dh_builddeb --destdir=$(DEB_DESTDIR)

#Architecture 
build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp: 
	dh_testdir
	$(MAKE) -C usr
	touch build-arch-stamp

build-indep: build-indep-stamp
build-indep-stamp: 
	touch build-indep-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp #CONFIGURE-STAMP#
	$(MAKE) -C usr clean
	dh_clean 

install: install-arch install-indep
install-indep:
	dh_testdir
	dh_testroot
	dh_clean -k -i 
	dh_installdirs -i
	
	# Create the directories to install the source into
	dh_installdirs -p$(psource)  usr/src/modules/$(PACKAGE)
	dh_installdirs -p$(psource)  usr/src/modules/$(PACKAGE)/debian
	dh_installdirs -p$(psource)  usr/src/modules/$(PACKAGE)/include
	dh_installdirs -p$(psource)  usr/src/modules/$(PACKAGE)/kernel
	
	# Copy only the driver source to the proper location
	cp kernel/*  debian/$(psource)/usr/src/modules/$(PACKAGE)/kernel/
	cp include/* debian/$(psource)/usr/src/modules/$(PACKAGE)/include/
	
	# Copy the needed debian/ pieces to the proper location
	cp debian/*-module-* \
		debian/$(psource)/usr/src/modules/$(PACKAGE)/debian
	cp debian/control.modules.in \
		debian/$(psource)/usr/src/modules/$(PACKAGE)/debian/control.in
	cp debian/rules \
		debian/$(psource)/usr/src/modules/$(PACKAGE)/debian
	cp debian/changelog \
		debian/$(psource)/usr/src/modules/$(PACKAGE)/debian
	cp debian/copyright \
		debian/$(psource)/usr/src/modules/$(PACKAGE)/debian
	
#	 install debian/ files
	cd debian ; cp changelog control compat *.modules.in rules copyright $(psource)/usr/src/modules/$(PACKAGE)/debian
	
#	 create toplevel module Makefile
	echo "obj-m = kernel/" > debian/$(psource)/usr/src/modules/$(PACKAGE)/Makefile
	
#	 tar the stuff
	cd debian/$(psource)/usr/src/ ; tar cvjf iscsitarget.tar.bz2 modules ; rm -rf modules
	
	install -m 755 $(CURDIR)/debian/modass.iscsitarget-source $(CURDIR)/debian/$(psource)/usr/share/modass/overrides/iscsitarget-source
	dh_install -i

install-arch:
	dh_testdir
	dh_testroot
	dh_clean -k -s 
	dh_installdirs -s
	dh_install -s
	
	# install override
	mkdir -p debian/iscsitarget/usr/share/lintian/overrides
	cp debian/iscsitarget.overrides \
		debian/iscsitarget/usr/share/lintian/overrides/iscsitarget
	


# Must not depend on anything. This is to be called by
# binary-arch/binary-indep
# in another 'make' thread.
binary-common:
	dh_testdir
	dh_testroot
	dh_installchangelogs ChangeLog
	dh_installdocs
	dh_installinit
	dh_installman
	dh_link
	dh_strip
	dh_compress 
	dh_fixperms
	chmod 600 $(CURDIR)/debian/iscsitarget/etc/ietd.conf
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb
# Build architecture independant packages using the common target.
binary-indep: build-indep install-indep
	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common

# Build architecture dependant packages using the common target.
binary-arch: build-arch install-arch
	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common

binary: binary-arch binary-indep
.PHONY: build clean binary-indep binary-arch binary install install-indep install-arch

## iscsitarget 1.4.20.2

=== debian/changelog ===
iscsitarget (1.4.20.2-6) unstable; urgency=low

  * SVN 1.4.20@453 - Co-ordinated with upstream on the stability of the tree
  * [494142b] Drop double installation of upstream changelog.
    Thanks to Christian Pernegger (Closes: #633005)
  * [71de4f8] Add package linux-headers to Recommends.
    Thanks to George Shuklin (Closes: 636157, 628428)
  * [8344c44] Add support to provide daemon options.
    Thanks to Alfredo Sola, Robbert Rijkse (Closes: 609582, 545536)
  * [8208ade] Drop debian/30-iscsitarget.conf. (Closes: 636497)
    We should not play with kernel sysct knobs right from the package.
    Setting those values will depend on a per machine basis
  * [0e96f0e] Update Standards Version to 3.9.2. No changes required

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sun, 07 Aug 2011 02:09:59 +0530

iscsitarget (1.4.20.2-5) experimental; urgency=low

  * Sync to 1.4.20 branch. This is equivalent of 1.4.20.3 and includes all
    commits up till revision 1.4.20@453
  * Add linux-headers packages to Suggests (Closes: #628428)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 14 Jun 2011 09:30:01 +0530

iscsitarget (1.4.20.2-4expr2) experimental; urgency=low

  * Sync to 1.4.20 branch. This is equivalent of 1.4.20.3 and includes all
    commits up till revision 1.4.20@445
    (Closes: #618682, #622318, #610309)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 26 Apr 2011 15:40:17 +0530

iscsitarget (1.4.20.2-4) unstable; urgency=low

  * Last upload was incorrect. Really upload to unstable now

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sat, 12 Feb 2011 01:59:17 +0530

iscsitarget (1.4.20.2-3) unstable; urgency=low

  * Upload to unstable

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 10 Feb 2011 20:13:59 +0530

iscsitarget (1.4.20.2-2) experimental; urgency=low

  [ Michael Prokop ]
  * NIPQUAD definition has been removed in kernel 2.6.36,
    adjust kernel/conn.c accordingly so iscsitarget compiles
    against kernel 2.6.36. (Closes: #604641)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sat, 08 Jan 2011 21:57:56 +0545

iscsitarget (1.4.20.2-1) unstable; urgency=low

  * New Upstream Bug Fix Release
  * Fix incorrect path installation. Correct path is /etc/iet/ 
  * Update Standards Version to 3.9.1 (No changes required) 
  * Add DKMS support for iscsitarget kernel module building 
  * Add iscsitarget-dkms to Suggests 
  * Change PID_FILE to ietd.pid. This was causing the ietd daemon to not
    be killed. Not very sure, perhaps upstream must have changed to ietd.pid
    from iscsi_trgt.pid (Closes: #589738)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 03 Aug 2010 13:38:08 +0530

iscsitarget (1.4.20.1-2) unstable; urgency=low

  * Change address to my official Debian address and remove the DMUA flag
  * Handle older kernel versions patches that upstream still supports. This
    should allow compiling iscsitarget with older kernels now.
    (Closes: #581200) 
  * Drop initiators.deny file in further installations which is already 
    deprecated upstream 
  * Switch config files directory to /etc/ietd as upstream recommends it and
    document this change in NEWS.Debian 
  * Add post-installation script to handle migration of old config file to the
    new location 

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sat, 05 Jun 2010 22:52:42 +0530

iscsitarget (1.4.20.1-1) unstable; urgency=low

  * New Upstream Bugfix Release 
  * Switch to 3.0 (quilt) source format 

 -- Ritesh Raj Sarraf <rrs@researchut.com>  Mon, 03 May 2010 14:24:52 +0530

iscsitarget (1.4.20-1) unstable; urgency=low

  [ Philipp Hug ]
  * This package is group maintained now
  * Changed maintainer to alioth project mailing list

  [ Ritesh Raj Sarraf ]
  * New Upstream Release (Closes: #566509)
  * Add myself to Uploaders
  * LSB-ize the iscsitarget init script (Closes: #506588, #546477) 
  * Add misc:Depends
  * Bump Standards Version. (No Changes Required) 
  * Add DM Upload: yes
  * Add debian/source/format specifying the source format 
  * Explain a little more about iscsitarget-module package and how it is
    made available, in README.Debian 
  * Add Vcs headers 

 -- Ritesh Raj Sarraf <rrs@researchut.com>  Sun, 18 Apr 2010 21:34:09 +0530

iscsitarget (0.4.17+svn229-1.4) unstable; urgency=low

  * Non-maintainer upload.
  * [f1d4105] Depend on procps (Closes: #569684)

 -- Guido Günther <agx@sigxcpu.org>  Tue, 16 Feb 2010 11:34:37 +0100

iscsitarget (0.4.17+svn229-1.3) unstable; urgency=low

  * Non-maintainer upload.
  * [2a179ca] Let propcs handle the sysctl knobs to  make it more obvious to
    the sysadmin what's going on. (Closes: #543604)

 -- Guido Günther <agx@sigxcpu.org>  Sat, 23 Jan 2010 17:36:12 +0100

iscsitarget (0.4.17+svn229-1.2) unstable; urgency=low

  * Non-maintainer upload.
  * Include patch from Petter Reinholdtsen <pere@debian.org>:
    - Fix incorrect provides and dependencies in init.d script
      (to solve release goal). (Closes: #542248)

 -- Michael Prokop <mika@debian.org>  Thu, 24 Sep 2009 00:05:36 +0200

iscsitarget (0.4.17+svn229-1.1) unstable; urgency=low

  * Non-maintainer upload. (Closes: #523374, #544941)
  * New upstream snapshot.
  * Bump Standards-Version to 3.8.3.

 -- Michael Prokop <mika@debian.org>  Fri, 11 Sep 2009 00:09:42 +0200

=== debian/control ===
Source: iscsitarget
Section: net
Priority: optional
Maintainer: Debian iSCSI Maintainers <pkg-iscsi-maintainers@lists.alioth.debian.org>
Uploaders: Philipp Hug <debian@hug.cx>, Guido Guenther <agx@sigxcpu.org>, Frederik Schüler <fs@debian.org>, Ritesh Raj Sarraf <rrs@debian.org>
Build-Depends: debhelper (>= 5.0.0), libssl-dev, bzip2
Standards-Version: 3.9.2
Homepage: http://iscsitarget.sourceforge.net/
Vcs-Git: git://git.debian.org/git/pkg-iscsi/iscsitarget.git
Vcs-Browser: http://git.debian.org/?p=pkg-iscsi/iscsitarget.git

Package: iscsitarget
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, procps, lsb-base (>= 3.2-14)
Recommends: iscsitarget-module
Suggests: iscsitarget-source, iscsitarget-dkms
Description: iSCSI Enterprise Target userland tools
 iSCSI Enterprise Target is for building an iSCSI storage system on
 Linux. It is aimed at developing an iSCSI target satisfying enterprise
 requirements.
 .
 This package contains the userland part; you require the kernel module 
 for proper operation.

Package: iscsitarget-source
Architecture: all
Depends: debhelper (>= 5.0.0), module-assistant, bzip2, ${misc:Depends}
Recommends: linux-headers
Description: iSCSI Enterprise Target kernel module source
 iSCSI Enterprise Target is for building an iSCSI storage system on
 Linux. It is aimed at developing an iSCSI target satisfying enterprise
 requirements.
 .
 This package provides the source code for the iscsitarget kernel module.
 The iscsitarget package is also required in order to make use of this
 module. Kernel source or headers are required to compile this module.

Package: iscsitarget-dkms
Architecture: all
Depends: dkms (>= 1.95), make, ${misc:Depends}
Recommends: linux-headers
Description: iSCSI Enterprise Target kernel module source - dkms version
 iSCSI Enterprise Target is for building an iSCSI storage system on
 Linux. It is aimed at developing an iSCSI target satisfying enterprise
 requirements.
 .
 This package provides the source code for the iscsitarget kernel module.
 The iscsitarget package is also required in order to make use of this
 module. Kernel source or headers are required to compile this module.
 .
 This package contains the source to be built with dkms.

=== debian/rules ===
--- 
+++ 
@@ -12,11 +12,25 @@
 # This has to be exported to make some magic below work.
 export DH_OPTIONS
 
+
+
+# get-orig-source target
+DEB_UPSTREAM_VERSION=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-]+).*,\1,p')
+
+get-orig-source:
+	[ ! -f $(ORIG_FILE).gz ] || rm -f $(ORIG_FILE).gz
+	uscan --force-download --rename --repack --download-version=$(DEB_UPSTREAM_VERSION) --destdir=.
+
+
+
 non_epoch_version=$(shell echo $(KVERS) | perl -pe 's/^\d+://')
 
 PACKAGE=iscsitarget
 psource=iscsitarget-source
 pmodules = $(PACKAGE)-module-$(non_epoch_version)
+
+# DKMS package
+pdkms=iscsitarget-dkms
 
 MA_DIR ?= /usr/share/modass
 -include $(MA_DIR)/include/generic.make
@@ -39,14 +53,112 @@
 KO=k
 endif
 
+KERN_VER=$(shell echo $(KVERS) | cut -d "-" -f1)
+
+# Taken from upstream iscsitarget's Makefile
+KMAJ := $(shell echo $(KERN_VER) | \
+	sed -e 's/^\([0-9][0-9]*\)\.[0-9][0-9]*\.[0-9][0-9]*.*/\1/')
+KMIN := $(shell echo $(KERN_VER) | \
+	sed -e 's/^[0-9][0-9]*\.\([0-9][0-9]*\)\.[0-9][0-9]*.*/\1/')
+KREV := $(shell echo $(KERN_VER) | \
+	sed -e 's/^[0-9][0-9]*\.[0-9][0-9]*\.\([0-9][0-9]*\).*/\1/')
+
+kver_eq = $(shell [ $(KMAJ)$(KMIN)$(KREV) -eq $(1)$(2)$(3) ] && \
+	echo 1 || echo 0)
+kver_lt = $(shell [ $(KMAJ)$(KMIN)$(KREV) -lt $(1)$(2)$(3) ] && \
+	echo 1 || echo 0)
+kver_le = $(shell [ $(KMAJ)$(KMIN)$(KREV) -le $(1)$(2)$(3) ] && \
+	echo 1 || echo 0)
+kver_gt = $(shell [ $(KMAJ)$(KMIN)$(KREV) -gt $(1)$(2)$(3) ] && \
+	echo 1 || echo 0)
+kver_ge = $(shell [ $(KMAJ)$(KMIN)$(KREV) -ge $(1)$(2)$(3) ] && \
+	echo 1 || echo 0)
+kver_lk = $(shell [ `echo $(KERN_VER) | egrep $(1)` ] && echo 1 || echo 0)
+
+# Compatibility patch for kernels >= 2.6.36  <= 2.6.38
+ifeq ($(call kver_le,2,6,38),1)
+	PATCHES := $(PATCHES) compat-2.6.36-2.6.37.patch
+endif
+
+# Compatibility patch for kernels > 2.6.32 <= 2.6.35
+ifeq ($(call kver_le,2,6,35),1)
+	PATCHES := $(PATCHES) compat-2.6.33-2.6.35.patch
+endif
+
+# Compatibility patch for kernels <= 2.6.32
+ifeq ($(call kver_le,2,6,32),1)
+	PATCHES := $(PATCHES) compat-2.6.32.patch
+endif
+
+# Compatibility patch for kernels <= 2.6.31
+ifeq ($(call kver_le,2,6,31),1)
+	PATCHES := $(PATCHES) compat-2.6.31.patch
+endif
+
+# Compatibility patch for kernels <= 2.6.30
+ifeq ($(call kver_le,2,6,30),1)
+	PATCHES := $(PATCHES) compat-2.6.30.patch
+endif
+
+# Compatibility patch for kernels <= 2.6.29
+ifeq ($(call kver_le,2,6,29),1)
+	PATCHES := $(PATCHES) compat-2.6.29.patch
+endif
+
+# Compatibility patch for kernels <= 2.6.28
+ifeq ($(call kver_le,2,6,28),1)
+	PATCHES := $(PATCHES) compat-2.6.28.patch
+endif
+
+# Compatibility patch for kernels >= 2.6.25 and <= 2.6.27
+ifeq ($(call kver_le,2,6,27),1)
+	PATCHES := $(PATCHES) compat-2.6.25-2.6.27.patch
+endif
+
+# Compatibility patch for kernels <= 2.6.24
+ifeq ($(call kver_le,2,6,24),1)
+	PATCHES := $(PATCHES) compat-2.6.24.patch
+endif
+
+# Compatibility patch for kernels <= 2.6.23
+ifeq ($(call kver_le,2,6,23),1)
+	PATCHES := $(PATCHES) compat-2.6.23.patch
+endif
+
+# Compatibility patch for kernels <= 2.6.22
+ifeq ($(call kver_le,2,6,22),1)
+	PATCHES := $(PATCHES) compat-2.6.22.patch
+endif
+
+# Compatibility patch for kernels >= 2.6.19 and <= 2.6.21
+ifeq ($(call kver_le,2,6,21),1)
+	PATCHES := $(PATCHES) compat-2.6.19-2.6.21.patch
+endif
+
+# Compatibility patch for kernels >= 2.6.14 and <= 2.6.18
+ifeq ($(call kver_le,2,6,18),1)
+	PATCHES := $(PATCHES) compat-2.6.14-2.6.18.patch
+endif
+
+# We don't support kernels < 2.6.14 except for explicit distros
+ifeq ($(call kver_lt,2,6,14),1)
+	echo "unsupported kernel"
+	exit 1
+endif
+
+
 kdist_clean:
 	dh_clean
-	 $(MAKE) -C $(KSRC) SUBDIRS=$(shell pwd)/kernel clean
+	$(MAKE) -C $(KSRC) SUBDIRS=$(shell pwd)/kernel clean
 
 # prep-deb-files rewrites the debian/ files as needed. See RATIONALE for
 # details
 kdist_config: prep-deb-files
-# ... additional kernel specific things to configure...
+	for p in $(PATCHES); do \
+		echo "Applying patch $$p"; \
+		test -f patches/$$p && patch -p1 < patches/$$p \
+		#test -f patches/compat-$(KERN_VER).patch && patch -p1 < patches/compat-$(KERN_VER).patch \
+	done
 
 kdist_configure: kdist_config
 
@@ -101,10 +213,12 @@
 	dh_installdirs -p$(psource)  usr/src/modules/$(PACKAGE)/debian
 	dh_installdirs -p$(psource)  usr/src/modules/$(PACKAGE)/include
 	dh_installdirs -p$(psource)  usr/src/modules/$(PACKAGE)/kernel
+	dh_installdirs -p$(psource)  usr/src/modules/$(PACKAGE)/patches
 	
 	# Copy only the driver source to the proper location
 	cp kernel/*  debian/$(psource)/usr/src/modules/$(PACKAGE)/kernel/
 	cp include/* debian/$(psource)/usr/src/modules/$(PACKAGE)/include/
+	cp patches/* debian/$(psource)/usr/src/modules/$(PACKAGE)/patches/
 	
 	# Copy the needed debian/ pieces to the proper location
 	cp debian/*-module-* \
@@ -118,60 +232,26 @@
 	cp debian/copyright \
 		debian/$(psource)/usr/src/modules/$(PACKAGE)/debian
 	
-#	 install debian/ files
+	# install debian/ files
 	cd debian ; cp changelog control compat *.modules.in rules copyright $(psource)/usr/src/modules/$(PACKAGE)/debian
 	
-#	 create toplevel module Makefile
+	# create toplevel module Makefile
 	echo "obj-m = kernel/" > debian/$(psource)/usr/src/modules/$(PACKAGE)/Makefile
 	
-#	 tar the stuff
-	cd debian/$(psource)/usr/src/ ; tar cvjf iscsitarget.tar.bz2 modules ; rm -rf modules
-	
-	install -m 755 $(CURDIR)/debian/modass.iscsitarget-source $(CURDIR)/debian/$(psource)/usr/share/modass/overrides/iscsitarget-source
-	dh_install -i
-
-install-arch:
-	dh_testdir
-	dh_testroot
-	dh_clean -k -s 
-	dh_installdirs -s
-	dh_install -s
-	
-	# install override
-	mkdir -p debian/iscsitarget/usr/share/lintian/overrides
-	cp debian/iscsitarget.overrides \
-		debian/iscsitarget/usr/share/lintian/overrides/iscsitarget
-	
-
-
-# Must not depend on anything. This is to be called by
-# binary-arch/binary-indep
-# in another 'make' thread.
-binary-common:
-	dh_testdir
-	dh_testroot
-	dh_installchangelogs ChangeLog
-	dh_installdocs
-	dh_installinit
-	dh_installman
-	dh_link
-	dh_strip
-	dh_compress 
-	dh_fixperms
-	chmod 600 $(CURDIR)/debian/iscsitarget/etc/ietd.conf
-	dh_makeshlibs
-	dh_installdeb
-	dh_shlibdeps
-	dh_gencontrol
-	dh_md5sums
-	dh_builddeb
-# Build architecture independant packages using the common target.
-binary-indep: build-indep install-indep
-	$(MAKE) -f debian/rules DH_OPTIONS=-i binary-common
-
-# Build architecture dependant packages using the common target.
-binary-arch: build-arch install-arch
-	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common
-
-binary: binary-arch binary-indep
-.PHONY: build clean binary-indep binary-arch binary install install-indep install-arch
+	# For DKMS
+	# Create the directories to install the source into
+	dh_installdirs -p$(pdkms)  usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)
+	dh_installdirs -p$(pdkms)  usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/debian
+	dh_installdirs -p$(pdkms)  usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/include
+	dh_installdirs -p$(pdkms)  usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/kernel
+	dh_installdirs -p$(pdkms)  usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/patches
+	
+	# Copy only the driver source to the proper location
+	cp kernel/*  debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/kernel/
+	cp include/* debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/include/
+	cp patches/* debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/patches/
+	
+	# Copy the needed debian/ pieces to the proper location
+	cp debian/*-module-* \
+		debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/debian
+	chmod 755 debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/debian/*-module-*

## iscsitarget 1.4.20.3%2bsvn499

=== debian/changelog ===
iscsitarget (1.4.20.3+svn499-0ubuntu2.1) trusty; urgency=low

  * Backport compat changes to allow DKMS compiles for kernels up to 3.19
    (LP: #1483415).
    - d/p/fix-build-3.19: Modifies source to compile with 3.19
    - d/p/add-compat-3.19: Adds compat patches without enabling them
    - d/p/enable-compat-3.19: Enables compat patches in the DKMS config
  * Add a check for the DKMS kernel module to d/tests/daemon dep-8 test
    (LP: #1496057)

 -- Stefan Bader <stefan.bader@canonical.com>  Wed, 16 Sep 2015 13:29:48 +0200

iscsitarget (1.4.20.3+svn499-0ubuntu2) trusty; urgency=medium

  * debian/patches/enable-3.12-compat.patch: Ensure patches are applied
    correctly by dkms for kernels < 3.13. 

 -- James Page <james.page@ubuntu.com>  Thu, 27 Mar 2014 20:14:11 +0000

iscsitarget (1.4.20.3+svn499-0ubuntu1) trusty; urgency=medium

  * New upstream snapshot including fixes for:
    - [r499] Compatibility with 3.13 kernel (LP: #1291641).
    - [r498] Fix backward compatibility patch rules for 3.x kernels.
    - [r497] Fix SERVICE ACTION IN / READ CAPACITY (16) - regression from r488.

 -- James Page <james.page@ubuntu.com>  Mon, 24 Mar 2014 13:13:42 +0000

iscsitarget (1.4.20.3+svn496-1ubuntu1) trusty; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - d/iscsitarget.init: If module unloading fails after stopping ietd,
      report it but still exit zero since this doesn't justify causing
      package operations to fail.
    - d/docs: Install README.initiators and README.mcs.
    - d/p/*: Tidied redundant patches.
  * Dropped, included in new snapshot:
    - Re-sync with upstream accepted patches for 3.7->3.10 kernel support:
      - d/p/iscsitarget-svn495.patch: Support for 3.7 and 3.8 kernels
      - d/p/iscsitarget-svn496.patch: Support kernels up to and including
        3.10.

 -- James Page <james.page@ubuntu.com>  Tue, 12 Nov 2013 11:11:50 +0000

iscsitarget (1.4.20.3+svn496-1) unstable; urgency=low

  * [798662d] Imported Upstream version 1.4.20.3+svn496
    Closes: #717155
  * [947f06d] Add README.source
  * [6e18336] Try harder to unload the kernel module.
    Thanks to David Mohr (Closes: #679515)
  * [ca83a57] Drop patch 001-fix-build-3.8.patch

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 26 Sep 2013 18:15:08 +0530

iscsitarget (1.4.20.3+svn490-2ubuntu1) saucy; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - d/iscsitarget.init: If module unloading fails after stopping ietd,
      report it but still exit zero since this doesn't justify causing
      package operations to fail.
    - d/docs: Install README.initiators and README.mcs.
  * Re-sync with upstream accepted patches for 3.7->3.10 kernel support:
    - d/p/iscsitarget-svn495.patch: Support for 3.7 and 3.8 kernels
    - d/p/iscsitarget-svn496.patch: Support kernels up to and including
      3.10.
  * Dropped:
    - d/p/001-fix-build-3.8.patch: Dropped in preference to upstream
      committed patch.
    - d/p/*: Tidied redundant patches.

 -- James Page <james.page@ubuntu.com>  Fri, 05 Jul 2013 09:04:22 +0100

iscsitarget (1.4.20.3+svn490-2) unstable; urgency=low

  * Upload to unstable

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sun, 16 Jun 2013 14:07:47 +0530

iscsitarget (1.4.20.3+svn490-1) experimental; urgency=low

  * [6457029] Imported Upstream version 1.4.20.3+svn490
    (Closes: #698757, #696383)
  * [22f9a74] Drop patches, applied upstream
    - inactive-sessions.patch
    - iscsitarget-prelim-1.4.20.3.patch
    - 0001-Makefile-changes-to-support-3.x-kernels.patch
    - 0002-Fix-send_data_rsp-to-handle-sense-data-correctly.patch
    - 0003-Compile-fix-for-kernels-3.1-and-3.2.patch
  * [1b1225b] Add patch 001-fix-build-3.8.patch

 -- Ritesh Raj Sarraf <rrs@researchut.com>  Fri, 12 Apr 2013 13:00:43 +0530

iscsitarget (1.4.20.2-11) experimental; urgency=low

  * [6dfdd7c] Add iscsitarget-dkms to Recommends and drop iscsitarget-module
  * [281b4a4] Update README.Debian explaining the new DKMS package.
    Thanks to Olaf van der Spek (Closes: #668382)
  * [a0d484c] Drop patch fix-build-3-2.patch
  * [afdf1df] Add patches from 1.4.20 stable branch (Closes: #685422)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sat, 15 Sep 2012 12:55:24 +0530

iscsitarget (1.4.20.2-10ubuntu4) saucy; urgency=low

  * d/p/fix-3.10-kernel-match.patch: Fixup patch pattern matching for
    >= 3.10 kernels.
  * d/p/kernel-3.10-support.patch: Add support for Linux 3.10
    (LP: #1195607).

 -- James Page <james.page@ubuntu.com>  Wed, 03 Jul 2013 09:27:28 +0100

iscsitarget (1.4.20.2-10ubuntu3) saucy; urgency=low

  * debian/tests: Add autopkgtest.

 -- Yolanda <yolanda.robla@canonical.com>  Fri, 10 May 2013 22:47:14 +0200

iscsitarget (1.4.20.2-10ubuntu2) raring; urgency=low

  * Fix compatibility with Linux 3.8 kernel (LP: #1117288):
    - d/p/iscsitarget-svn486.patch: Cherry picked patch from upstream VCS
      which adds support for 3.6 kernel.
    - d/p/fix-dkms.conf: Refreshed for backward compat < 3.6,3.8 kernel.
    - d/p/kernel-3.8-compat.patch: Fix compatibility Linux 3.8 kernel.

 -- James Page <james.page@ubuntu.com>  Tue, 12 Mar 2013 10:13:09 +0000

iscsitarget (1.4.20.2-10ubuntu1) quantal; urgency=low

  * Merge from Debian testing.  Remaining changes:
    - d/iscsitarget.init: If module unloading fails after stopping ietd,
      report it but still exit zero since this doesn't justify causing
      package operations to fail.
    - d/docs: Install README.initiators and README.mcs.
    - d/p/fix-send-data-rsp.patch: Pick change @462 from upstream svn to
      prevent a assertion failure in iscsi.c@492.
    - d/p/linux-3.2-includes.patch: Add additional includes of linux/export.h
      and linux/module.h, resolving dkms build failures with > linux 3.2.
    - d/p/fix-dkms.patch: Add missing patch entries to the dkms.conf file.
  * Fix DKMS compatibility with Linux 3.5 kernel (LP: #1045706):
    - d/p/iscsitarget-svn{444,471}.patch: Cherry picked patches from
